#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  A copy of the GNU General Public License is available at
#  http://www.r-project.org/Licenses/


#library("bitops")
#require("bitops")
BITlowbit<- function (x)#calculating lowbit
{
    if (requireNamespace("bitops", quietly = TRUE)) {
        bitops::bitAnd(x,-x)
    }
#    bitAnd(x,-x)
}

#Chage the value of the ith element to val
BITadd<- function(i,val,BIT,n)
{
    while(i< n)
    {
        BIT[i]=BIT[i]+val
        i=BITlowbit(i)+i
    }
	BIT
}

#sum of the elements from first to ith
BITsum<-function(i,BIT) 
{
    s=0;
    while(i>0)
    {
        s=s+BIT[i];
        i=i-BITlowbit(i);
    }
    s
}

#Normalizing the input data
WKnormalize<-function(pin, min=0.0000001)
{
    pout=(pin-min(pin))/(max(pin)-min(pin))
    pout[pout==0]=min
    pout
}

#Main function
fWKendall <- function(xin,yin)
{
 
#    library("bitops")
   if (length(xin)!=length(yin))
    {
        print("The length are different!")
        return (0)
    }
	x=WKnormalize(xin)
	y=WKnormalize(yin)
	Iset=order(x,y)

	n=length(Iset)
	
	Rep=rep(0,n)    #C_3
	Zero=rep(0,n)   #C_1

    #Calculating the Zero and Rep array
	for (i in (n-1):1)
	{
		if (x[Iset[i+1]]==x[Iset[i]])
		{
			Zero[i]=Zero[i+1]+x[Iset[i+1]]/y[Iset[i+1]]
			if (y[Iset[i+1]]==y[Iset[i]])   #x_i==x_{i+1}, y_i==y_{i+1}
			{
				Rep[i]=Rep[i+1]+1
			}
		}
	}
	
	########################
	#Calculating the BITxy structure
	########################
	ORDxy=order(x/y) 
	Oxy=(x/y)[ORDxy] 
	ORDrxy=rep(0,n)   
	BITxy=rep(0,n)	
	
	for (j in 1:n)		
	{
		if (j!=1 && Oxy[j]==Oxy[j-1])
		{
			ORDrxy[ORDxy[j]]=ORDrxy[ORDxy[j-1]]
		}
		else
			ORDrxy[ORDxy[j]]=j	
		BITxy=BITadd(j,Oxy[j],BITxy,n+1)	
	}



	########################
	#Calculating the BITyx structure
	########################
	ORDyx=order(y/x) 
	Oyx=(y/x)[ORDyx] 
	ORDryx=rep(0,n)   
	BITyx=rep(0,n)	  
	repryx=rep(0,n)
	for (j in 1:n)		
	{
		if (j!=1 && Oyx[j]==Oyx[j-1])
		{
			ORDryx[ORDyx[j]]=ORDryx[ORDyx[j-1]]
		}
		else
			ORDryx[ORDyx[j]]=j	
		BITyx=BITadd(j,Oyx[j],BITyx,n+1)	
	}
	repryx=rep(0,n)
	for (j in (n-1):1)		
	{
		if (ORDryx[ORDyx[j]]==ORDryx[ORDyx[j+1]])
		{
			repryx[j]=repryx[j+1]+1
		}
	}

	########################
	#Calculating the BIToy structure
	########################
	ORDoy=order(y) 
	Ooy=(y/x)[ORDoy] 
	ORDroy=rep(0,n)   
	ORDrRoy=rep(0,n) 
	BIToy=rep(0,n)	 

    BITcy=rep(0,n)	 
	for (j in 1:n)	
	{
		if (j!=1 && y[ORDoy[j]]==y[ORDoy[j-1]])
		{
			ORDroy[ORDoy[j]]=ORDroy[ORDoy[j-1]]
		}
		else
			ORDroy[ORDoy[j]]=j
		ORDrRoy[ORDoy[j]]=j	
		BIToy=BITadd(j,Ooy[j],BIToy,n+1)	
		BITcy=BITadd(j,1,BITcy,n+1)
	}
	reproy=rep(0,n)
	for (j in (n-1):1)	
	{
		if (y[ORDoy[j]]==y[ORDoy[j+1]])
		{
			reproy[j]=reproy[j+1]+1
		}
	}
	
	########################
    # Nov 1, 2016
	########################
	#Calculating the BITtxy structure
	########################
	ORDtxy=order(x*y) 
	Otxy=(x*y)[ORDtxy] 
	ORDrtxy=rep(0,n)   
	BITtxy=rep(0,n)	
	
	for (j in 1:n)		
	{
		if (j!=1 && Otxy[j]==Otxy[j-1])
		{
			ORDrtxy[ORDtxy[j]]=ORDrtxy[ORDtxy[j-1]]
		}
		else
			ORDrtxy[ORDtxy[j]]=j	
		BITtxy=BITadd(j,Otxy[j],BITtxy,n+1)	
	}
	########################
	#Calculating the BITdxy structure
	########################
	ORDdxy=order(1/(x*y), decreasing = T) 
	Odxy=(1/(x*y))[ORDdxy] 
	ORDrdxy=rep(0,n)   
	BITdxy=rep(0,n)	
	
	for (j in 1:n)		
	{
		if (j!=1 && Odxy[j]==Odxy[j-1])
		{
			ORDrdxy[ORDdxy[j]]=ORDrdxy[ORDdxy[j-1]]
		}
		else
			ORDrdxy[ORDdxy[j]]=j	
		BITdxy=BITadd(j,Odxy[j],BITdxy,n+1)	
	}
	########################
	#Calculating the BITkxy structure
	########################
	ORDkxy=order(y) 
	Okxy=(1/(x*y))[ORDkxy] 
	ORDrkxy=rep(0,n)   
	BITkxy=rep(0,n)	
	
	for (j in 1:n)		
	{
		if (j!=1 && Okxy[j]==Okxy[j-1])
		{
			ORDrkxy[ORDkxy[j]]=ORDrkxy[ORDkxy[j-1]]
		}
		else
			ORDrkxy[ORDkxy[j]]=j	
		BITkxy=BITadd(j,Okxy[j],BITkxy,n+1)	
	}

	########################
    # End    
	########################

	
	#########################################
    # Start computing the correlation
	#########################################
	j=0
	wd=0
	repyx=0
	repoy=0
	for (i in Iset)	# ith iteration
	{
		j=j+1
		if (ORDrxy[i]>1)    #Computes the sum of x/y from BITxy for x[j]/y[j] < x[i]/y[i]
			sumxy=BITsum(ORDrxy[i]-1,BITxy)
		else
			sumxy=0
		BITxy=BITadd(ORDrxy[i],-Oxy[ORDrxy[i]],BITxy,n+1)

		if (ORDryx[i]>1)    #Computes the sum of y/x from BITyx for y[j]/x[j] < y[i]/x[i]
		{
			sumyx=BITsum(ORDryx[i]-1,BITyx) #S_{D1}
		}
		else
			sumyx=0
		repyx=BITsum(ORDryx[i]-1+repryx[ORDryx[i]]+1,BITyx)
		BITyx=BITadd(ORDryx[i],-Oyx[ORDryx[i]],BITyx,n+1) 

		if (ORDroy[i]>1)    #Computes the sum of y/x from BIToy for y[j] < y[i]
		{
			sumoy=BITsum(ORDroy[i]-1,BIToy)
            sumcy=BITsum(ORDroy[i]-1,BITcy)
		}
		else
        {
			sumoy=0
            sumcy=0
        }
		repoy=BITsum(ORDroy[i]-1+reproy[ORDroy[i]]+1,BIToy)
		BIToy=BITadd(ORDrRoy[i],-Ooy[ORDrRoy[i]],BIToy,n+1)
		BITcy=BITadd(ORDrRoy[i],-1,BITcy,n+1)
	
	########################
    # Nov 1, 2016
	########################
		if (ORDrtxy[i]>1)    #Computes the sum of xy from BITtxy for x[j]y[j] < x[i]y[i]
			sumtxy=BITsum(ORDrtxy[i]-1,BITtxy)
		else
			sumtxy=0
		BITtxy=BITadd(ORDrtxy[i],-Otxy[ORDrtxy[i]],BITtxy,n+1)

		if (ORDrdxy[i]>1)    #Computes the sum of 1/(xy) from BITdxy for 1/(x[j]y[j]) > 1(x[i]y[i])
			sumdxy=BITsum(ORDrdxy[i]-1,BITdxy)
		else
			sumdxy=0
		BITdxy=BITadd(ORDrdxy[i],-Odxy[ORDrdxy[i]],BITdxy,n+1)

		if (ORDrkxy[i]>1)    #Computes the sum of 1/(xy) from BITkxy for y[j] < y[i]
			sumkxy=BITsum(ORDrkxy[i]-1,BITkxy)
		else
			sumkxy=0
		BITkxy=BITadd(ORDrkxy[i],-Okxy[ORDrkxy[i]],BITkxy,n+1)

        v1=sumtxy/(x[i]*y[i])
        v2=(sumkxy-sumdxy)*(x[i]*y[i])
#		cat(i,sumkxy-sumdxy,sumkxy,sumdxy,sumtxy,v1,v2,"\n",sep="\t")
        w5=-(v1+v2)
	########################
    # End    
	########################

		w6=sumxy/(x[i]/y[i])-(Zero[j]-Rep[j])/(x[i]/y[i])	#sumxy: Case6+Case7+Case1
#		w6=sumxy/(x[i]/y[i])-Zero[j]/(x[i]/y[i])+Rep[j]	#sumxy: Case6+Case7+Case1
		#Zero includes Case1 and Case3
        #w6=S_{D6}-S_{D1}=S_{D6}-{Zero-S_{case_3}}
#		w5=sumoy*(x[i]/y[i])-sumcy		#sumoy: Case 5
#		w5=-sumoy*(x[i]/y[i])		#sumoy: Case 5
#		w5=(sumoy-sumcy)*(x[i]/y[i])		#sumoy: Case 5
		w4=(repyx-repoy)*(x[i]/y[i])

#        if (sumoy>0)
#    		w5=-(x[i]/y[i])/sumoy		#sumoy: Case 5
#        else
#            w5=0

#        if (repyx-repoy>0)
#    		w4=(x[i]/y[i])/(repyx-repoy)
#        else
 #           w4=0


		w3=Rep[j]
		w2=repoy-sumoy
		w1=Zero[j]
	
		wd=wd+w3+w4+w5+w6   #sum the weight of current iteration 
	}
    return(wd/(n*(n-1)/2))    #return the correlation
}

